import { Action, combineReducers } from 'redux';

import * as signin from './signin';
import * as signout from './signout';
import * as signup from './signup';

export const ModuleName = 'member';

export interface StateRecord {
  signin: signin.StateRecord;
  signout: signout.StateRecord;
  signup: signup.StateRecord;
}

export interface IActionTypes {
  signin: signin.IActionTypes;
  signout: signout.IActionTypes;
  signup: signup.IActionTypes;
}
export const ActionTypes: IActionTypes = {
  signin: signin.ActionTypes,
  signout: signout.ActionTypes,
  signup: signup.ActionTypes,
};

export interface IActions {
  signin: signin.IActions;
  signout: signout.IActions;
  signup: signup.IActions;
}
export const Actions: IActions = {
  signin: signin.Actions,
  signout: signout.Actions,
  signup: signup.Actions,
};



export const Reducers = combineReducers<StateRecord>({
  signin: signin.Reducers,
  signout: signout.Reducers,
  signup: signup.Reducers,
});

