import Action from 'commons/redux/Action';
import { Record, makeRecordFactory } from 'commons/util/immutable/Record';
import { Member } from 'member/api/model/Member';
export type REQUEST = '@overflow/member/signout/REQUEST';
export type REQUEST_SUCCESS = '@overflow/member/signout/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/member/signout/REQUEST_FAILURE';

export const ModuleName = 'signout';

export interface State {
}

export interface StateRecord extends Record<StateRecord>, State {
}

const makeStateRecord = makeRecordFactory<State, StateRecord>({
});


export interface IActionTypes {
  REQUEST: REQUEST;
  REQUEST_SUCCESS: REQUEST_SUCCESS;
  REQUEST_FAILURE: REQUEST_FAILURE;
}
export const ActionTypes: IActionTypes = {
  REQUEST: '@overflow/member/signout/REQUEST',
  REQUEST_SUCCESS: '@overflow/member/signout/REQUEST_SUCCESS',
  REQUEST_FAILURE: '@overflow/member/signout/REQUEST_FAILURE',
};

export interface IActions {
  request: () => Action;
  requestSuccess: () => Action;
  requestFailure: (error: Error) => Action;
}
export const Actions: IActions = {
    request(): Action {
      return {
          type: ActionTypes.REQUEST,
        };
    },

    requestSuccess(): Action {
      return {
          type: ActionTypes.REQUEST,
        };
    },

    requestFailure(error: Error): Action {
      return {
          type: ActionTypes.REQUEST,
          error: error,
        };
    },
};

export function Reducers(state: StateRecord = makeStateRecord(), action: Action): StateRecord {
  switch (action.type) {
    case ActionTypes.REQUEST_SUCCESS:
    {
      return state.merge({isAuthenticated: true, member: action.payload});
    }
    case ActionTypes.REQUEST_FAILURE:
    {
      return state.merge({isAuthenticated: false, error: action.error});
    }
    default:
      return state;
  }
}
